Index: main/trunk/greenstone2/perllib/plugins/DSpacePlugin.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/DSpacePlugin.pm	(revision 31479)
+++ main/trunk/greenstone2/perllib/plugins/DSpacePlugin.pm	(revision 31480)
@@ -152,5 +152,5 @@
 
     if (&FileUtils::fileTest($handle_filename)) {
-	&util::block_filename($block_hash,$handle_filename);
+	$self->block_raw_filename($block_hash,$handle_filename);
     }
 }
Index: main/trunk/greenstone2/perllib/plugins/GreenstoneXMLPlugin.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/GreenstoneXMLPlugin.pm	(revision 31479)
+++ main/trunk/greenstone2/perllib/plugins/GreenstoneXMLPlugin.pm	(revision 31480)
@@ -110,5 +110,5 @@
     $file =~ s/^[\/\\]+//; # $file often begins with / so we'll tidy it up
     
-    print $outhandle "GreenstoneXMLlugin: setting up block list for $file\n"
+    print $outhandle "GreenstoneXMLPlugin: setting up block list for $file\n"
 	if $self->{'verbosity'} > 1;
 
@@ -126,5 +126,7 @@
 		}
 
-		&util::block_filename($block_hash,$full_gsdl_assoc_filename);		
+		# is this raw filename here, or unicode?? assuming unicode
+		# however we have concatenated raw directory???
+		$self->block_filename($block_hash,$full_gsdl_assoc_filename);		
 	    }
 	}
Index: main/trunk/greenstone2/perllib/plugins/HTMLPlugin.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/HTMLPlugin.pm	(revision 31479)
+++ main/trunk/greenstone2/perllib/plugins/HTMLPlugin.pm	(revision 31480)
@@ -290,10 +290,11 @@
 		if($unicode_url_original_filename ne $unicode_html_fname) {
 			# Allow for possibility of raw byte version and Unicode versions of file
-			&util::block_filename($block_hash,$unicode_url_original_filename);
+			$self->block_filename($block_hash,$unicode_url_original_filename);
 		}
 	}
 
 	# $url_original_filename = &util::upgrade_if_dos_filename($url_original_filename);
-	&util::block_filename($block_hash,$url_original_filename) if $url_original_filename ne $html_fname;
+	# TODO now use unicode files in block, do we need this??
+	#$self->block_raw_filename($block_hash,$url_original_filename) if $url_original_filename ne $html_fname;
 
 	# but only add the linked file to the blocklist if the current html file does not link to itself
@@ -1292,5 +1293,5 @@
 		$unicode_dirname = &unicode::raw_filename_to_url_encoded($dirname);
 	    }
-	
+	    print STDERR "unicode dirname = ".&unicode::debug_unicode_string($unicode_dirname)."\n";
 	    $before_hash = &FileUtils::filenameConcatenate($unicode_dirname, $before_hash);
 	    $before_hash = $self->eval_dir_dots($before_hash);	 
Index: main/trunk/greenstone2/perllib/plugins/HathiTrustMETSPlugin.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/HathiTrustMETSPlugin.pm	(revision 31479)
+++ main/trunk/greenstone2/perllib/plugins/HathiTrustMETSPlugin.pm	(revision 31480)
@@ -514,6 +514,6 @@
     my ($file_root) = ($filename_full_path =~ m/^(.*)\.mets\.xml$/);
 
-    &util::block_filename($block_hash,"$file_root.zip");
-    &util::block_filename($block_hash,"$file_root.json");
+    $self->block_raw_filename($block_hash,"$file_root.zip");
+    $self->block_raw_filename($block_hash,"$file_root.json");
 
     my $page_dir = $file_root;
@@ -530,6 +530,6 @@
 	    my $txt_filename = &FileUtils::filenameConcatenate($page_dir,$1);
 	    my $topics_filename = $txt_filename . ".topics";
-	    &util::block_filename($block_hash,$txt_filename);
-	    &util::block_filename($block_hash,$topics_filename);
+	    $self->block_raw_filename($block_hash,$txt_filename);
+	    $self->block_raw_filename($block_hash,$topics_filename);
 	}
     }
Index: main/trunk/greenstone2/perllib/plugins/ISISPlugin.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/ISISPlugin.pm	(revision 31479)
+++ main/trunk/greenstone2/perllib/plugins/ISISPlugin.pm	(revision 31480)
@@ -143,10 +143,10 @@
 	print STDERR "$self->{'fdt_file_path'}\n";
 	my $fdt_file = $self->{'fdt_file_path'};
-	&util::block_filename($block_hash,$fdt_file);
+	$self->block_raw_filename($block_hash,$fdt_file);
     }
     if (-e $self->{'xrf_file_path'}) {
 	print STDERR "$self->{'xrf_file_path'}\n";
 	my $xrf_file = $self->{'xrf_file_path'};
-	&util::block_filename($block_hash,$xrf_file);
+	$self->block_raw_filename($block_hash,$xrf_file);
     }
     
Index: main/trunk/greenstone2/perllib/plugins/MetadataCSVPlugin.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/MetadataCSVPlugin.pm	(revision 31479)
+++ main/trunk/greenstone2/perllib/plugins/MetadataCSVPlugin.pm	(revision 31480)
@@ -120,5 +120,5 @@
 
     # add the file to the block list so that it won't be processed in read, as we will do all we can with it here
-    &util::block_filename($block_hash,$filename);
+    $self->block_raw_filename($block_hash,$filename);
 
 
Index: main/trunk/greenstone2/perllib/plugins/MetadataXMLPlugin.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/MetadataXMLPlugin.pm	(revision 31479)
+++ main/trunk/greenstone2/perllib/plugins/MetadataXMLPlugin.pm	(revision 31480)
@@ -258,5 +258,5 @@
     print $outhandle "MetadataXMLPlugin: processing $file\n" if ($self->{'verbosity'})> 1;
     # add the file to the block list so that it won't be processed in read, as we will do all we can with it here
-    &util::block_filename($block_hash,$filename);
+    $self->block_raw_filename($block_hash,$filename);
 
     $self->{'metadataref'} = $extrametadata;
Index: main/trunk/greenstone2/perllib/plugins/PagedImagePlugin.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/PagedImagePlugin.pm	(revision 31479)
+++ main/trunk/greenstone2/perllib/plugins/PagedImagePlugin.pm	(revision 31480)
@@ -647,8 +647,8 @@
 
 	if ($line =~ /imgfile=\"([^\"]+)\"/) {
-	    &util::block_filename($block_hash,&FileUtils::filenameConcatenate($dir,$1));
+	    $self->block_raw_filename($block_hash,&FileUtils::filenameConcatenate($dir,$1));
 	}
 	if ($line =~ /txtfile=\"([^\"]+)\"/) {
-	    &util::block_filename($block_hash,&FileUtils::filenameConcatenate($dir,$1));
+	    $self->block_raw_filename($block_hash,&FileUtils::filenameConcatenate($dir,$1));
 	}
     }
@@ -677,9 +677,9 @@
 	# find the image file if there is one
 	if (defined $imgname && $imgname ne "") {
-	    &util::block_filename($block_hash, &FileUtils::filenameConcatenate( $dir,$imgname));
+	    $self->block_raw_filename($block_hash, &FileUtils::filenameConcatenate( $dir,$imgname));
 	}
 	# find the text file if there is one
 	if (defined $txtname && $txtname ne "") {
-	    &util::block_filename($block_hash, &FileUtils::filenameConcatenate($dir,$txtname));
+	    $self->block_raw_filename($block_hash, &FileUtils::filenameConcatenate($dir,$txtname));
 	}
     }