Index: /main/trunk/greenstone3/build.properties.in
===================================================================
--- /main/trunk/greenstone3/build.properties.in	(revision 31488)
+++ /main/trunk/greenstone3/build.properties.in	(revision 31489)
@@ -3,4 +3,8 @@
 
 ## Tomcat installation
+
+# The protocol (http, https)
+server.protocol=http
+
 # Set this to the internet/intranet name of the machine that Tomcat is/will be 
 # run on. localhost is fine for accessing the server from the local machine, 
@@ -18,4 +22,8 @@
 # The context name of your GS3 digital library. By default this will be "greenstone3". Ensure this has a value.
 greenstone.context=greenstone3
+
+# solr generally lives off /solr from the base greenstone URL
+solr.context=solr
+
 
 ## If creating a GS3 set up with a dispersed web folder ("web-dispersed" GS3), with GS3 in a read-only location, then 
Index: /main/trunk/greenstone3/build.xml
===================================================================
--- /main/trunk/greenstone3/build.xml	(revision 31488)
+++ /main/trunk/greenstone3/build.xml	(revision 31489)
@@ -835,6 +835,10 @@
 
   <target name="get-default-servlet-url">
-    <echo>http://${tomcat.server}:${tomcat.port}${app.path}${server.default.servlet}</echo>
-  </target> 
+    <echo>${server.protocol}://${tomcat.server}:${tomcat.port}${app.path}${server.default.servlet}</echo>
+  </target>
+
+  <target name="get-solr-servlet-url">
+    <echo>${server.protocol}://${tomcat.server}:${tomcat.port}/${solr.context}</echo>
+  </target>
 
   <target name="check-derbyserver-running">
@@ -925,7 +929,7 @@
     </if>
     <if><bool><isset property="install.flax"/></bool>
-        <property name="url" value="http://${tomcat.server}:${tomcat.port}${app.path}/flax"/>
+        <property name="url" value="${server.protocol}://${tomcat.server}:${tomcat.port}${app.path}/flax"/>
     <else>
-        <property name="url" value="http://${tomcat.server}:${tomcat.port}${app.path}/"/>
+        <property name="url" value="${server.protocol}://${tomcat.server}:${tomcat.port}${app.path}/"/>
     </else>
     </if>
@@ -1602,5 +1606,5 @@
       <and>
         <socket server="${tomcat.server}" port="${tomcat.port}"/>
-        <http url="http://${tomcat.server}:${tomcat.port}${app.path}/index.html"/>
+        <http url="${server.protocol}://${tomcat.server}:${tomcat.port}${app.path}/index.html"/>
       </and>
     </waitfor>
@@ -1611,5 +1615,5 @@
     <if><bool><istrue value="${tomcat.isstarted}"/></bool>
       <echo>**************************************</echo>
-      <echo>A WEB SERVER IS ALREADY RUNNING ON http://${tomcat.server}:${tomcat.port}. NOT STARTING.</echo>
+      <echo>A WEB SERVER IS ALREADY RUNNING ON ${server.protocol}://${tomcat.server}:${tomcat.port}. NOT STARTING.</echo>
       <echo>**************************************</echo>
       <else>
@@ -1667,5 +1671,5 @@
       <and>
         <socket server="${tomcat.server}" port="${tomcat.port}"/>
-        <http url="http://${tomcat.server}:${tomcat.port}${app.path}/index.html"/>
+        <http url="${server.protocol}://${tomcat.server}:${tomcat.port}${app.path}/index.html"/>
       </and>
     </waitfor>
@@ -1676,5 +1680,5 @@
   <target name="reconfigure" description="Reconfigure the message router">
     <waitfor maxwait="5" maxwaitunit="second">
-      <http url="http://${tomcat.server}:${tomcat.port}${app.path}${server.default.servlet}?a=s&amp;sa=c"/>
+      <http url="${server.protocol}://${tomcat.server}:${tomcat.port}${app.path}${server.default.servlet}?a=s&amp;sa=c"/>
     </waitfor>
   </target>
@@ -1683,5 +1687,5 @@
   <target name="reconfigure-collection" description="Reconfigure the collection">
     <waitfor maxwait="5" maxwaitunit="second">
-      <http url="http://${tomcat.server}:${tomcat.port}${app.path}${server.default.servlet}?a=s&amp;sa=c&amp;sc=${collection}"/>
+      <http url="${server.protocol}://${tomcat.server}:${tomcat.port}${app.path}${server.default.servlet}?a=s&amp;sa=c&amp;sc=${collection}"/>
     </waitfor>
   </target>
@@ -1716,6 +1720,6 @@
   <target name="check-tomcat-running">
     <condition property="tomcat.isrunning">
-      <!--<http url="http://${tomcat.server}:${tomcat.port}${app.path}"/>-->
-      <http url="http://${tomcat.server}:${tomcat.port}"/>
+      <!--<http url="${server.protocol}://${tomcat.server}:${tomcat.port}${app.path}"/>-->
+      <http url="${server.protocol}://${tomcat.server}:${tomcat.port}"/>
     </condition>
   </target>
@@ -1726,5 +1730,5 @@
   <target name="check-tomcat-started">
     <condition property="tomcat.isstarted">
-      <http url="http://${tomcat.server}:${tomcat.port}"/>
+      <http url="${server.protocol}://${tomcat.server}:${tomcat.port}"/>
     </condition>
   </target>
@@ -2023,5 +2027,5 @@
       <classpath refid="compile.classpath"/>
       <arg value="-l"/>
-      <arg value="http://${tomcat.server}:${tomcat.port}${app.path}/servlet/AxisServlet"/>
+      <arg value="${server.protocol}://${tomcat.server}:${tomcat.port}${app.path}/servlet/AxisServlet"/>
       <arg file="${basedir}/resources/soap/deploy.wsdd"/>
     </java>
@@ -2039,5 +2043,5 @@
       <classpath refid="compile.classpath"/>
       <arg value="-l"/>
-      <arg value="http://${tomcat.server}:${tomcat.port}${app.path}/servlet/AxisServlet"/>
+      <arg value="${server.protocol}://${tomcat.server}:${tomcat.port}${app.path}/servlet/AxisServlet"/>
       <arg file="${basedir}/resources/soap/undeploy.wsdd"/>
     </java>
@@ -2071,5 +2075,5 @@
   <target name="get-undeploy-service-name" unless="axis.undeploy.servicename">
     <input addproperty="axis.undeploy.servicename" defaultvalue="localsite">Please enter the full name of the service you wish to undeploy.
-To find out which web services you've got deployed, point your browser to http://HOST:PORT/greenstone3/services 
+To find out which web services you've got deployed, point your browser to ${server.protocol}://${tomcat.server}:${tomcat.port}/greenstone3/services 
 Or press Enter for undeploying the default:localsite /&gt;</input>
      <echo>Name of service to undeploy: ${axis.undeploy.servicename}</echo>
@@ -3370,5 +3374,5 @@
 				<java classname="org.junit.runner.JUnitCore" fork="true">
 					<arg value="gstests.TestClass"/>
-					<jvmarg value="-DSERVERURL=http://${tomcat.server}:${tomcat.port}${app.path}${server.default.servlet} "/>
+					<jvmarg value="-DSERVERURL=${server.protocol}://${tomcat.server}:${tomcat.port}${app.path}${server.default.servlet} "/>
 					<classpath>
 						<fileset dir="${basedir}/ext/testing/lib/java">