Index: /main/trunk/greenstone2/perllib/plugins/BookPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/BookPlugin.pm	(revision 31493)
+++ /main/trunk/greenstone2/perllib/plugins/BookPlugin.pm	(revision 31494)
@@ -67,5 +67,5 @@
 	'deft' => &get_default_process_exp() },
       { 'name' => "block_exp",
-	'desc' => "{BaseImporter.block_exp}",
+	'desc' => "{CommonUtil.block_exp}",
 	'type' => "regexp",
 	'reqd' => "no",
Index: /main/trunk/greenstone2/perllib/plugins/CONTENTdmPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/CONTENTdmPlugin.pm	(revision 31493)
+++ /main/trunk/greenstone2/perllib/plugins/CONTENTdmPlugin.pm	(revision 31494)
@@ -76,5 +76,5 @@
 	'reqd' => "no" },
       { 'name' => "block_exp",
-	'desc' => "{BaseImporter.block_exp}",
+	'desc' => "{CommonUtil.block_exp}",
 	'type' => "regexp",
 	'deft' => &get_default_block_exp() }
Index: /main/trunk/greenstone2/perllib/plugins/CommonUtil.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/CommonUtil.pm	(revision 31493)
+++ /main/trunk/greenstone2/perllib/plugins/CommonUtil.pm	(revision 31494)
@@ -44,9 +44,9 @@
 our $encoding_list =
     [ { 'name' => "ascii",
-	'desc' => "{BaseImporter.encoding.ascii}" },
+	'desc' => "{CommonUtil.encoding.ascii}" },
       { 'name' => "utf8",
-	'desc' => "{BaseImporter.encoding.utf8}" },
+	'desc' => "{CommonUtil.encoding.utf8}" },
       { 'name' => "unicode",
-	'desc' => "{BaseImporter.encoding.unicode}" } ];
+	'desc' => "{CommonUtil.encoding.unicode}" } ];
 
 
@@ -63,13 +63,13 @@
 our $encoding_plus_auto_list = 
     [ { 'name' => "auto",
-	'desc' => "{BaseImporter.filename_encoding.auto}" },
+	'desc' => "{CommonUtil.filename_encoding.auto}" },
       { 'name' => "auto-language-analysis",
-	'desc' => "{BaseImporter.filename_encoding.auto_language_analysis}" }, # textcat
+	'desc' => "{CommonUtil.filename_encoding.auto_language_analysis}" }, # textcat
       { 'name' => "auto-filesystem-encoding",
-	'desc' => "{BaseImporter.filename_encoding.auto_filesystem_encoding}" }, # locale
+	'desc' => "{CommonUtil.filename_encoding.auto_filesystem_encoding}" }, # locale
       { 'name' => "auto-fl",
-	'desc' => "{BaseImporter.filename_encoding.auto_fl}" }, # locale followed by textcat
+	'desc' => "{CommonUtil.filename_encoding.auto_fl}" }, # locale followed by textcat
       { 'name' => "auto-lf",
-	'desc' => "{BaseImporter.filename_encoding.auto_lf}" } ]; # texcat followed by locale 
+	'desc' => "{CommonUtil.filename_encoding.auto_lf}" } ]; # texcat followed by locale 
 
 push(@{$encoding_plus_auto_list},@{$encoding_list});
@@ -77,14 +77,14 @@
 my $arguments =
     [  { 'name' => "block_exp",
-	 'desc' => "{BaseImporter.block_exp}",
+	 'desc' => "{CommonUtil.block_exp}",
 	 'type' => "regexp",
 	 'deft' => "",
 	 'reqd' => "no" },
        { 'name' => "no_blocking",
-	 'desc' => "{BaseImporter.no_blocking}",
+	 'desc' => "{CommonUtil.no_blocking}",
 	 'type' => "flag",
 	 'reqd' => "no"},
        { 'name' => "filename_encoding",
-	 'desc' => "{BaseImporter.filename_encoding}",
+	 'desc' => "{CommonUtil.filename_encoding}",
 	 'type' => "enum",
 	 'deft' => "auto",
@@ -267,5 +267,5 @@
     my $outhandle = $self->{'outhandle'};
 
-    print $outhandle "****!!!!**** BaseImporter::filename_to_utf8_metadata now deprecated\n";
+    print $outhandle "****!!!!**** CommonUtil::filename_to_utf8_metadata now deprecated\n";
     my ($cpackage,$cfilename,$cline,$csubr,$chas_args,$cwantarray) = caller(0);
     print $outhandle "Calling method: $cfilename:$cline $cpackage->$csubr\n";
@@ -363,5 +363,5 @@
     {
 	if ($self->{'verbosity'}) { 
-	    gsprintf($outhandle, "BaseImporter: {ReadTextFile.unsupported_encoding}\n", $text, $best_encoding, "undef");
+	    gsprintf($outhandle, "CommonUtil: {ReadTextFile.unsupported_encoding}\n", $text, $best_encoding, "undef");
 	}
 	$best_encoding = undef;
Index: /main/trunk/greenstone2/perllib/plugins/DSpacePlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/DSpacePlugin.pm	(revision 31493)
+++ /main/trunk/greenstone2/perllib/plugins/DSpacePlugin.pm	(revision 31494)
@@ -79,5 +79,5 @@
 	'reqd' => "no" },
       { 'name' => "block_exp",
-	'desc' => "{BaseImporter.block_exp}",
+	'desc' => "{CommonUtil.block_exp}",
 	'type' => "regexp",
 	'deft' => &get_default_block_exp(),
Index: /main/trunk/greenstone2/perllib/plugins/DirectoryPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/DirectoryPlugin.pm	(revision 31493)
+++ /main/trunk/greenstone2/perllib/plugins/DirectoryPlugin.pm	(revision 31494)
@@ -52,5 +52,5 @@
 my $arguments =
     [ { 'name' => "block_exp",
-	'desc' => "{BaseImporter.block_exp}",
+	'desc' => "{CommonUtil.block_exp}",
 	'type' => "regexp",
 	'deft' => &get_default_block_exp(),
Index: /main/trunk/greenstone2/perllib/plugins/FOXPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/FOXPlugin.pm	(revision 31493)
+++ /main/trunk/greenstone2/perllib/plugins/FOXPlugin.pm	(revision 31494)
@@ -51,5 +51,5 @@
 	'deft' => &get_default_process_exp() },
       { 'name' => "block_exp",
-	'desc' => "{BaseImporter.block_exp}",
+	'desc' => "{CommonUtil.block_exp}",
 	'type' => "regexp",
 	'reqd' => "no",
Index: /main/trunk/greenstone2/perllib/plugins/HBPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/HBPlugin.pm	(revision 31493)
+++ /main/trunk/greenstone2/perllib/plugins/HBPlugin.pm	(revision 31494)
@@ -54,5 +54,5 @@
 my $encoding_list =     
     [ { 'name' => "ascii",
-	'desc' => "{BaseImporter.encoding.ascii}" },
+	'desc' => "{CommonUtil.encoding.ascii}" },
       { 'name' => "iso_8859_1",
 	'desc' => "{HBPlugin.encoding.iso_8859_1}" } ];
Index: /main/trunk/greenstone2/perllib/plugins/HTMLPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/HTMLPlugin.pm	(revision 31493)
+++ /main/trunk/greenstone2/perllib/plugins/HTMLPlugin.pm	(revision 31494)
@@ -66,5 +66,5 @@
 	'deft' =>  &get_default_process_exp() },
       { 'name' => "block_exp",
-	'desc' => "{BaseImporter.block_exp}",
+	'desc' => "{CommonUtil.block_exp}",
 	'type' => 'regexp',
 	'deft' =>  &get_default_block_exp() },
Index: /main/trunk/greenstone2/perllib/plugins/ISISPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/ISISPlugin.pm	(revision 31493)
+++ /main/trunk/greenstone2/perllib/plugins/ISISPlugin.pm	(revision 31494)
@@ -51,5 +51,5 @@
 	'deft' => &get_default_process_exp() },
       { 'name' => "block_exp",
-	'desc' => "{BaseImporter.block_exp}",
+	'desc' => "{CommonUtil.block_exp}",
 	'type' => "regexp",
 	'reqd' => "no",
Index: /main/trunk/greenstone2/perllib/plugins/PDFPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/PDFPlugin.pm	(revision 31493)
+++ /main/trunk/greenstone2/perllib/plugins/PDFPlugin.pm	(revision 31494)
@@ -67,5 +67,5 @@
        'reqd' => "no" },
      { 'name' => "block_exp",
-       'desc' => "{BaseImporter.block_exp}",
+       'desc' => "{CommonUtil.block_exp}",
        'type' => "regexp",
        'deft' => &get_default_block_exp() },
Index: /main/trunk/greenstone2/perllib/plugins/PostScriptPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/PostScriptPlugin.pm	(revision 31493)
+++ /main/trunk/greenstone2/perllib/plugins/PostScriptPlugin.pm	(revision 31494)
@@ -63,5 +63,5 @@
 	'reqd' => "no" },
       { 'name' => "block_exp",
-	'desc' => "{BaseImporter.block_exp}",
+	'desc' => "{CommonUtil.block_exp}",
 	'type' => 'regexp',
 	'deft' => &get_default_block_exp() },
Index: /main/trunk/greenstone2/perllib/plugins/SourceCodePlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/SourceCodePlugin.pm	(revision 31493)
+++ /main/trunk/greenstone2/perllib/plugins/SourceCodePlugin.pm	(revision 31494)
@@ -54,5 +54,5 @@
 	'reqd' => "no" } ,
       { 'name' => "block_exp",
-	'desc' => "{BaseImporter.block_exp}",
+	'desc' => "{CommonUtil.block_exp}",
 	'type' => "regexp",
 	'deft' => &get_default_block_exp(),