Index: main/trunk/greenstone2/perllib/strings_es.properties
===================================================================
--- main/trunk/greenstone2/perllib/strings_es.properties	(revision 29976)
+++ main/trunk/greenstone2/perllib/strings_es.properties	(revision 31495)
@@ -764,53 +764,53 @@
 BaseMediaConverter.desc:Conector que provee funcionalidad bÃ¡sica para los conectores conversores de media como el ImageConverter y los conversores de video.
 
-BasePlugin.associate_ext:Hace que los ficheros cuyos nombres contienen la misma parte inicial que el documento procesado por el plugin y una extensiÃ³n que figura en la lista separada por comas que provee este argumento, sean asociados con el documento que se estÃ¡ procesando en vez de ser manejados como una lista separada.
-
-BasePlugin.associate_tail_re:Una expresiÃ³n regular para cotejar con los nombres de archivos y encontrar los archivos asociados.
-
-BasePlugin.block_exp:Los archivos que sean iguales a esta expresiÃ³n regular serÃ¡n bloqueados para no pasarse a ningÃºn otro plugin posterior del listado.
-
-BasePlugin.desc:La clase base para todos los plugins de importaciÃ³n.
-
-BasePlugin.dummy_text:Este documento no tiene contenido.
-
-BasePlugin.encoding.ascii:ASCII plano de 7 bits. Ãste puede resultar mÃ¡s rÃ¡pido que usando el iso_8859_1. Tenga cuidado con usar esto en una colecciÃ³n de documentos que pueden contener caracteres no comprendidos en el conjunto ASCII simple (por ejemplo documentos en AlemÃ¡n o FrancÃ©s que contengan acentos), mejor utilice el iso_8859_1.
-
-BasePlugin.encoding.unicode:SÃ³lo unicode.
-
-BasePlugin.encoding.utf8:Ya sea Utf8 o unicodeâdetectada automÃ¡ticamente
-
-BasePlugin.filename_encoding:La codificaciÃ³n de los nombres de archivos de origen.
-
-BasePlugin.filename_encoding.auto:Detectar automÃ¡ticamente la codificaciÃ³n del nombre de archivo.
-
-BasePlugin.filename_encoding.auto_language_analysis:Auto detectar la codificaciÃ³n analizando el nombre de archivo.
-
-BasePlugin.filename_encoding.auto_filesystem_encoding:Auto detectar la codificaciÃ³n del nombre de archivo usando la codificaciÃ³n del filesystem.
-
-BasePlugin.filename_encoding.auto_fl:Utiliza la codificaciÃ³n del filesystem y luego anÃ¡lisis de idioma para detectar la codificaciÃ³n del nombre de archivo.
-
-BasePlugin.filename_encoding.auto_lf:Utilizar anÃ¡lisis de idioma y luego codificaciÃ³n del filesystem para detectar la codificaciÃ³n del nombre de archivo.
-
-BasePlugin.no_blocking:No hacer bloqueo de archivos. Cualquier archivo asociado (ej. ImÃ¡genes en una pÃ¡gina web) serÃ¡ agregado a la colecciÃ³n como documentos separados.
-
-BasePlugin.no_cover_image:No buscar un archivo prefijo.jpg (en el cual prefijo es el mismo prefijo que el del archivo que estÃ¡ siendo procesado) para asociarlo como imagen de portada.
-
-BasePlugin.OIDtype.auto:Usar OIDType definido en import.pl
-
-BasePlugin.process_exp:Una expresiÃ³n Perl regular para comprobar contra nombres de ficheros que se procesarÃ¡n por este plugin. Por ej., usando '(? i). html? \ $' aparecerÃ¡n todos los documentos con terminaciÃ³n. htm .html (no es sensible a mayÃºsculas/minÃºsculas).
-
-BasePlugin.processing_tmp_files:Marca interna, fijada por los plugins conversores para indicar que estÃ¡n procesando un archivo tmp.
-
-BasePlugin.smart_block:Bloquear archivos en una forma mÃ¡s inteligente que simplemente examinando sus nombres.
-
-BasePlugin.store_original_file:Grabar el documento original como un documento asociado. Note que esto ya es asÃ­ para documentos PDF, Word, etc. Esta opciÃ³n solo es util para plugins que no hacen copia del archivo original.
-
-BasePlugin.file_rename_method:El mÃ©todo a utilizarse para renombrar la copia de los archivos importados y asociados.
-
-BasePlugin.rename_method.url:Usar codificaciÃ³n de URL al renombrar archivos importados y asociados.
-
-BasePlugin.rename_method.base64:Usar codificaciÃ³n base64 para renombrar archivos importados y asociados.
-
-BasePlugin.rename_method.none:No renombrar archivos importados y asociados.
+BaseImporter.associate_ext:Hace que los ficheros cuyos nombres contienen la misma parte inicial que el documento procesado por el plugin y una extensiÃ³n que figura en la lista separada por comas que provee este argumento, sean asociados con el documento que se estÃ¡ procesando en vez de ser manejados como una lista separada.
+
+BaseImporter.associate_tail_re:Una expresiÃ³n regular para cotejar con los nombres de archivos y encontrar los archivos asociados.
+
+CommonUtil.block_exp:Los archivos que sean iguales a esta expresiÃ³n regular serÃ¡n bloqueados para no pasarse a ningÃºn otro plugin posterior del listado.
+
+BaseImporter.desc:La clase base para todos los plugins de importaciÃ³n.
+
+BaseImporter.dummy_text:Este documento no tiene contenido.
+
+CommonUtil.encoding.ascii:ASCII plano de 7 bits. Ãste puede resultar mÃ¡s rÃ¡pido que usando el iso_8859_1. Tenga cuidado con usar esto en una colecciÃ³n de documentos que pueden contener caracteres no comprendidos en el conjunto ASCII simple (por ejemplo documentos en AlemÃ¡n o FrancÃ©s que contengan acentos), mejor utilice el iso_8859_1.
+
+CommonUtil.encoding.unicode:SÃ³lo unicode.
+
+CommonUtil.encoding.utf8:Ya sea Utf8 o unicodeâdetectada automÃ¡ticamente
+
+CommonUtil.filename_encoding:La codificaciÃ³n de los nombres de archivos de origen.
+
+CommonUtil.filename_encoding.auto:Detectar automÃ¡ticamente la codificaciÃ³n del nombre de archivo.
+
+CommonUtil.filename_encoding.auto_language_analysis:Auto detectar la codificaciÃ³n analizando el nombre de archivo.
+
+CommonUtil.filename_encoding.auto_filesystem_encoding:Auto detectar la codificaciÃ³n del nombre de archivo usando la codificaciÃ³n del filesystem.
+
+CommonUtil.filename_encoding.auto_fl:Utiliza la codificaciÃ³n del filesystem y luego anÃ¡lisis de idioma para detectar la codificaciÃ³n del nombre de archivo.
+
+CommonUtil.filename_encoding.auto_lf:Utilizar anÃ¡lisis de idioma y luego codificaciÃ³n del filesystem para detectar la codificaciÃ³n del nombre de archivo.
+
+CommonUtil.no_blocking:No hacer bloqueo de archivos. Cualquier archivo asociado (ej. ImÃ¡genes en una pÃ¡gina web) serÃ¡ agregado a la colecciÃ³n como documentos separados.
+
+BaseImporter.no_cover_image:No buscar un archivo prefijo.jpg (en el cual prefijo es el mismo prefijo que el del archivo que estÃ¡ siendo procesado) para asociarlo como imagen de portada.
+
+BaseImporter.OIDtype.auto:Usar OIDType definido en import.pl
+
+BaseImporter.process_exp:Una expresiÃ³n Perl regular para comprobar contra nombres de ficheros que se procesarÃ¡n por este plugin. Por ej., usando '(? i). html? \ $' aparecerÃ¡n todos los documentos con terminaciÃ³n. htm .html (no es sensible a mayÃºsculas/minÃºsculas).
+
+BaseImporter.processing_tmp_files:Marca interna, fijada por los plugins conversores para indicar que estÃ¡n procesando un archivo tmp.
+
+BaseImporter.smart_block:Bloquear archivos en una forma mÃ¡s inteligente que simplemente examinando sus nombres.
+
+BaseImporter.store_original_file:Grabar el documento original como un documento asociado. Note que esto ya es asÃ­ para documentos PDF, Word, etc. Esta opciÃ³n solo es util para plugins que no hacen copia del archivo original.
+
+BaseImporter.file_rename_method:El mÃ©todo a utilizarse para renombrar la copia de los archivos importados y asociados.
+
+BaseImporter.rename_method.url:Usar codificaciÃ³n de URL al renombrar archivos importados y asociados.
+
+BaseImporter.rename_method.base64:Usar codificaciÃ³n base64 para renombrar archivos importados y asociados.
+
+BaseImporter.rename_method.none:No renombrar archivos importados y asociados.
 
 BibTexPlugin.desc:BibTexPlugin lee archivos de registros bibliogrÃ¡ficos en formato BibTex. BibTexPlugin crea un objeto de documento para cada referencia en el archivo. Es una subclase de SplitTextFile, por lo que si hay registros mÃºltiples, todos se leen.
@@ -1087,5 +1087,5 @@
 MetadataCSVPlugin.desc:Plugin para metadatos en formato de valores separados pro comas. El campo Filename del fichero CSV se usa para determinar a que documento pertenece el metadato.
 
-MetadataPass.desc:Clase base separada a BasePlugin que soporta que los conectores de metadato utilicen la pasada metadata_read del import.pl
+MetadataPass.desc:Clase base separada a BaseImporter que soporta que los conectores de metadato utilicen la pasada metadata_read del import.pl
 
 MetadataXMLPlugin.desc:Conector que procesa archivos metadata.xml.